From: "Ionen Wolkens" <ionen@gentoo.org>
To: gentoo-commits@lists.gentoo.org
Subject: [gentoo-commits] repo/gentoo:master commit in: app-emulation/dxvk/
Date: Mon, 07 Apr 2025 15:05:35 +0000 (UTC) [thread overview]
Message-ID: <1744038319.51ab4b7dfc1851c865366457ad56c014fc0b867d.ionen@gentoo> (raw)
commit: 51ab4b7dfc1851c865366457ad56c014fc0b867d
Author: Ionen Wolkens <ionen <AT> gentoo <DOT> org>
AuthorDate: Mon Apr 7 14:54:08 2025 +0000
Commit: Ionen Wolkens <ionen <AT> gentoo <DOT> org>
CommitDate: Mon Apr 7 15:05:19 2025 +0000
URL: https://gitweb.gentoo.org/repo/gentoo.git/commit/?id=51ab4b7d
app-emulation/dxvk: add 2.6.1
Signed-off-by: Ionen Wolkens <ionen <AT> gentoo.org>
app-emulation/dxvk/Manifest | 1 +
app-emulation/dxvk/dxvk-2.6.1.ebuild | 177 +++++++++++++++++++++++++++++++++++
2 files changed, 178 insertions(+)
diff --git a/app-emulation/dxvk/Manifest b/app-emulation/dxvk/Manifest
index 70357fcb74cd..e1bfff2b15a1 100644
--- a/app-emulation/dxvk/Manifest
+++ b/app-emulation/dxvk/Manifest
@@ -1,6 +1,7 @@
DIST dxvk-2.3.1.tar.gz 1005669 BLAKE2B d78448fcde9d600f7206dfa606fca4069e7563bb8b181fbc172691d6c45586904ae529550926a03612ed3cc1f2a2dff00990638125c1d7ce6179d3cd3ba8df04 SHA512 085567ac263872eb93d776ce7cf982690603e240a977dbb51ad69344af387fd745536ca62819afd4a809732a6f2d22b36c3df9538decf37dec527973d41e392f
DIST dxvk-2.4.1.tar.gz 1060662 BLAKE2B 43294af5829fe306acdb72c07b94c28d34eb798a2eaf6d2e42c2b80900e9b6f4f323569dfd51d565c836237fddce26b843f69e4ff57fc2a5838382993a9dd6ed SHA512 629e45bbdaddf83cd8a394877289781e8f54330b4c865b2d453ba3068a6054511a3697ca115497b64df0ce9ee36748a7fdb01fdc5f49a7dc44c4a3d3e47bf6de
DIST dxvk-2.5.3.tar.gz 1142475 BLAKE2B 04bfb577902effec9e22b6546cdfc2b3dd76b84e72c23cb26ac4e54f7aa9464b15d7d74b41dd810fc62d4fff9bbb24cee2771f562a7b931025abfa5995b000bc SHA512 93de46ab69dceea9e13904d9f267a53295a885676bce432c13d992ea33553250e03a695caf15f2c0a9a416c0ed3d799a9155a09dcadfeb43e516780fb188b122
+DIST dxvk-2.6.1.tar.gz 1209938 BLAKE2B 590a83297c0f4adc7828326cbb782103e1030e84c009d3983a756e285ea495cd55232a3e86626563a90fec328514c591a5d331df0cef51a8c422cb36fe723552 SHA512 0fcdfcacfecbcac2c638e2746d78759d144288975c7ee493b69d5dbcb3f13099e1472fd9ae50e52c12702f9fd74c91da8b1da5f8e6f96467826135947317829b
DIST dxvk-2.6.tar.gz 1202585 BLAKE2B 5fe8f928dcb38b7842dcb6c8263e6e8d7f32a41722d331686e592b9424c2f2e8e5ba04808b99bd22be6da67ed554cfc7877fdca8608c886ca5845eba4528a9e1 SHA512 7b70cc5106716751603781c26377aeedd6180bba1872646f0d5d90e42167667ba79f9131c1a6050d87642da74563cd0d638f8c62e70b727a50e788e8d597f8dc
DIST libdisplay-info-275e6459c7ab1ddd4b125f28d0440716e4888078.tar.bz2 81172 BLAKE2B 7a1e9e2feeb95e06e9d3f49ad9d14a8a152cca525085e819cda0b69c238fb79dddd6d547cd0f0a4b51dfc1ec74ac4c006345b9fc48563807bc8ab3bab58ea5ff SHA512 794e94e8c16d65901a7b705d1ba3361817b4e9e19e520b1004bcab232d0347f5713594d67f3c2b79d4f86b3012e710c648975547d27a63de043fcbe9e6b7e66d
DIST setup_dxvk.sh 4631 BLAKE2B 25270e1f6dfd446b1d124eac3bd19da8bc770527d02d987949fc3ae0bead07866dafa25f77a90b9a408413a724354a29a4a156ff5c9dc75e26b66e079824ec86 SHA512 257fd84e29a7037f04a1a2a506502c71d527af58f8c84d8c3dfb64597ebdc41c3dca362eaf20ab4bc1982b76428c1f843815d56a6e1369d072e0009e270cb121
diff --git a/app-emulation/dxvk/dxvk-2.6.1.ebuild b/app-emulation/dxvk/dxvk-2.6.1.ebuild
new file mode 100644
index 000000000000..5700f2a8b954
--- /dev/null
+++ b/app-emulation/dxvk/dxvk-2.6.1.ebuild
@@ -0,0 +1,177 @@
+# Copyright 2022-2025 Gentoo Authors
+# Distributed under the terms of the GNU General Public License v2
+
+EAPI=8
+
+PYTHON_COMPAT=( python3_{10..13} )
+MULTILIB_ABIS="amd64 x86" # allow usage on /no-multilib/
+MULTILIB_COMPAT=( abi_x86_{32,64} )
+inherit eapi9-ver flag-o-matic meson-multilib python-any-r1
+
+if [[ ${PV} == 9999 ]]; then
+ inherit git-r3
+ EGIT_REPO_URI="https://github.com/doitsujin/dxvk.git"
+ EGIT_SUBMODULES=(
+ # picky about headers and is cross-compiled making -I/usr/include troublesome
+ include/{spirv,vulkan}
+ subprojects/libdisplay-info
+ )
+else
+ HASH_SPIRV=8b246ff75c6615ba4532fe4fde20f1be090c3764
+ HASH_VULKAN=234c4b7370a8ea3239a214c9e871e4b17c89f4ab
+ HASH_DISPLAYINFO=275e6459c7ab1ddd4b125f28d0440716e4888078
+ SRC_URI="
+ https://github.com/doitsujin/dxvk/archive/refs/tags/v${PV}.tar.gz
+ -> ${P}.tar.gz
+ https://github.com/KhronosGroup/SPIRV-Headers/archive/${HASH_SPIRV}.tar.gz
+ -> spirv-headers-${HASH_SPIRV}.tar.gz
+ https://github.com/KhronosGroup/Vulkan-Headers/archive/${HASH_VULKAN}.tar.gz
+ -> vulkan-headers-${HASH_VULKAN}.tar.gz
+ https://gitlab.freedesktop.org/JoshuaAshton/libdisplay-info/-/archive/${HASH_DISPLAYINFO}/libdisplay-info-${HASH_DISPLAYINFO}.tar.bz2
+ "
+ KEYWORDS="-* ~amd64 ~x86"
+fi
+
+DESCRIPTION="Vulkan-based implementation of D3D9, D3D10 and D3D11 for Linux / Wine"
+HOMEPAGE="https://github.com/doitsujin/dxvk/"
+
+# setup_dxvk.sh is no longer provided, fetch old until a better solution
+SRC_URI+=" https://raw.githubusercontent.com/doitsujin/dxvk/cd21cd7fa3b0df3e0819e21ca700b7627a838d69/setup_dxvk.sh"
+
+LICENSE="ZLIB Apache-2.0 MIT"
+SLOT="0"
+IUSE="+abi_x86_32 crossdev-mingw +d3d8 +d3d9 +d3d10 +d3d11 +dxgi +strip"
+REQUIRED_USE="
+ || ( d3d8 d3d9 d3d10 d3d11 dxgi )
+ d3d8? ( d3d9 )
+ d3d10? ( d3d11 )
+ d3d11? ( dxgi )
+"
+
+BDEPEND="
+ ${PYTHON_DEPS}
+ dev-util/glslang
+ !crossdev-mingw? ( dev-util/mingw64-toolchain[${MULTILIB_USEDEP}] )
+"
+
+PATCHES=(
+ "${FILESDIR}"/${PN}-1.10.3-wow64-setup.patch
+ "${FILESDIR}"/${PN}-2.4-d3d8-setup.patch
+)
+
+pkg_pretend() {
+ [[ ${MERGE_TYPE} == binary ]] && return
+
+ if use crossdev-mingw && [[ ! -v MINGW_BYPASS ]]; then
+ local tool=-w64-mingw32-g++
+ for tool in $(usev abi_x86_64 x86_64${tool}) $(usev abi_x86_32 i686${tool}); do
+ if ! type -P ${tool} >/dev/null; then
+ eerror "With USE=crossdev-mingw, it is necessary to setup the mingw toolchain."
+ eerror "For instructions, please see: https://wiki.gentoo.org/wiki/Mingw"
+ use abi_x86_32 && use abi_x86_64 &&
+ eerror "Also, with USE=abi_x86_32, will need both i686 and x86_64 toolchains."
+ die "USE=crossdev-mingw is set but ${tool} was not found"
+ elif [[ ! $(LC_ALL=C ${tool} -v 2>&1) =~ "Thread model: posix" ]]; then
+ eerror "${PN} requires GCC to be built with --enable-threads=posix"
+ eerror "Please see: https://wiki.gentoo.org/wiki/Mingw#POSIX_threads_for_Windows"
+ die "USE=crossdev-mingw is set but ${tool} does not use POSIX threads"
+ fi
+ done
+ fi
+}
+
+src_prepare() {
+ if [[ ${PV} != 9999 ]]; then
+ rmdir include/{spirv,vulkan} subprojects/libdisplay-info || die
+ mv ../SPIRV-Headers-${HASH_SPIRV} include/spirv || die
+ mv ../Vulkan-Headers-${HASH_VULKAN} include/vulkan || die
+ mv ../libdisplay-info-${HASH_DISPLAYINFO} subprojects/libdisplay-info || die
+ fi
+ cp -- "${DISTDIR}"/setup_dxvk.sh . || die
+
+ default
+
+ sed -i "/^basedir=/s|=.*|=${EPREFIX}/usr/lib/${PN}|" setup_dxvk.sh || die
+}
+
+src_configure() {
+ use crossdev-mingw || PATH=${BROOT}/usr/lib/mingw64-toolchain/bin:${PATH}
+
+ # random segfaults been reported with LTO in some games, filter as
+ # a safety (note that optimizing this further won't really help
+ # performance, GPU does the actual work)
+ filter-lto
+
+ # -mavx and mingw-gcc do not mix safely here
+ # https://github.com/doitsujin/dxvk/issues/4746#issuecomment-2708869202
+ append-flags -mno-avx
+
+ if [[ ${CHOST} != *-mingw* ]]; then
+ if [[ ! -v MINGW_BYPASS ]]; then
+ unset AR CC CXX RC STRIP
+ filter-flags '-fuse-ld=*'
+ filter-flags '-mfunction-return=thunk*' #878849
+
+ # some bashrc-mv users tend to do CFLAGS="${LDFLAGS}" and then
+ # strip-unsupported-flags miss these during compile-only tests
+ # (primarily done for 23.0 profiles' -z, not full coverage)
+ filter-flags '-Wl,-z,*' #928038
+ fi
+
+ CHOST_amd64=x86_64-w64-mingw32
+ CHOST_x86=i686-w64-mingw32
+ CHOST=$(usex x86 ${CHOST_x86} ${CHOST_amd64})
+
+ strip-unsupported-flags
+ fi
+
+ multilib-minimal_src_configure
+}
+
+multilib_src_configure() {
+ # multilib's ${CHOST_amd64}-gcc -m32 is unusable with crossdev,
+ # unset again so meson eclass will set ${CHOST}-gcc + others
+ use crossdev-mingw && [[ ! -v MINGW_BYPASS ]] && unset AR CC CXX RC STRIP
+
+ local emesonargs=(
+ --prefix="${EPREFIX}"/usr/lib/${PN}
+ --{bin,lib}dir=x${MULTILIB_ABI_FLAG: -2}
+ --force-fallback-for=libdisplay-info # system's is ELF (unusable)
+ $(meson_use {,enable_}d3d8)
+ $(meson_use {,enable_}d3d9)
+ $(meson_use {,enable_}d3d10)
+ $(meson_use {,enable_}d3d11)
+ $(meson_use {,enable_}dxgi)
+ $(usev strip --strip) # portage won't strip .dll, so allow it here
+ )
+
+ meson_src_configure
+}
+
+multilib_src_install_all() {
+ dobin setup_dxvk.sh
+ dodoc README.md dxvk.conf
+
+ find "${ED}" -type f -name '*.a' -delete || die
+}
+
+pkg_postinst() {
+ if [[ ! ${REPLACING_VERSIONS} ]]; then
+ elog "To enable ${PN} on a wine prefix, you can run the following command:"
+ elog
+ elog " WINEPREFIX=/path/to/prefix setup_dxvk.sh install --symlink"
+ elog
+ elog "See ${EROOT}/usr/share/doc/${PF}/README.md* for details."
+ elog "Note: setup_dxvk.sh is unofficially temporarily provided as it was"
+ elog "removed upstream, handling may change in the future."
+ fi
+
+ if use d3d8 && ver_replacing -lt 2.4; then
+ elog
+ elog ">=${PN}-2.4 now provides d3d8.dll, to make use of it will need to"
+ elog "update old wine prefixes which is typically done by re-running:"
+ elog
+ elog " WINEPREFIX=/path/to/prefix setup_dxvk.sh install --symlink"
+ elog
+ fi
+}
next reply other threads:[~2025-04-07 15:05 UTC|newest]
Thread overview: 81+ messages / expand[flat|nested] mbox.gz Atom feed top
2025-04-07 15:05 Ionen Wolkens [this message]
-- strict thread matches above, loose matches on Subject: below --
2025-04-02 9:28 [gentoo-commits] repo/gentoo:master commit in: app-emulation/dxvk/ Arthur Zamarin
2025-04-02 9:28 Arthur Zamarin
2025-03-13 22:10 Ionen Wolkens
2025-03-09 14:41 Ionen Wolkens
2025-02-14 8:00 Ionen Wolkens
2025-02-14 8:00 Ionen Wolkens
2025-02-05 14:10 Jakov Smolić
2025-02-05 11:27 Sam James
2025-01-22 9:55 Ionen Wolkens
2025-01-13 16:16 Ionen Wolkens
2024-12-31 23:51 Ionen Wolkens
2024-12-31 12:47 Sam James
2024-12-31 9:57 Sam James
2024-12-20 16:14 Ionen Wolkens
2024-12-10 18:53 Sam James
2024-12-10 14:37 Arthur Zamarin
2024-12-10 9:53 Ionen Wolkens
2024-11-18 12:07 Ionen Wolkens
2024-11-11 23:22 Ionen Wolkens
2024-11-11 23:22 Ionen Wolkens
2024-11-04 16:15 Ionen Wolkens
2024-10-16 7:41 Sam James
2024-10-16 7:41 Sam James
2024-09-26 23:05 Ionen Wolkens
2024-07-30 18:00 Arthur Zamarin
2024-07-30 18:00 Arthur Zamarin
2024-07-10 12:18 Ionen Wolkens
2024-05-22 3:32 Ionen Wolkens
2024-05-21 3:01 Ionen Wolkens
2024-05-10 4:26 Ionen Wolkens
2024-05-07 14:28 Ionen Wolkens
2024-04-27 21:46 Sam James
2024-04-27 21:46 Sam James
2024-03-28 10:10 Ionen Wolkens
2024-03-27 16:45 Ionen Wolkens
2024-03-24 18:39 Ionen Wolkens
2024-03-20 13:37 Ionen Wolkens
2024-03-20 13:37 Ionen Wolkens
2024-03-20 7:17 Ionen Wolkens
2024-02-09 16:18 Ionen Wolkens
2024-02-09 16:18 Ionen Wolkens
2023-10-01 13:35 Sam James
2023-10-01 13:35 Sam James
2023-09-04 17:12 Ionen Wolkens
2023-08-16 21:38 Ionen Wolkens
2023-08-15 20:22 Ionen Wolkens
2023-08-10 10:53 Ionen Wolkens
2023-06-26 10:12 Ionen Wolkens
2023-06-08 12:24 Arthur Zamarin
2023-06-08 12:23 Arthur Zamarin
2023-06-02 6:54 Ionen Wolkens
2023-05-25 4:16 Ionen Wolkens
2023-05-12 11:59 Ionen Wolkens
2023-05-12 11:59 Ionen Wolkens
2023-04-29 9:43 Ionen Wolkens
2023-04-17 20:44 Ionen Wolkens
2023-02-13 11:46 Ionen Wolkens
2023-01-24 21:40 Ionen Wolkens
2023-01-24 21:40 Ionen Wolkens
2022-12-15 21:32 Ionen Wolkens
2022-12-14 16:56 Ionen Wolkens
2022-11-29 15:02 Ionen Wolkens
2022-11-29 13:25 Ionen Wolkens
2022-11-29 12:13 Ionen Wolkens
2022-11-10 23:50 Ionen Wolkens
2022-11-10 23:50 Ionen Wolkens
2022-11-10 23:50 Ionen Wolkens
2022-10-31 0:54 Ionen Wolkens
2022-10-23 7:20 Ionen Wolkens
2022-09-27 23:46 Ionen Wolkens
2022-09-14 23:11 Ionen Wolkens
2022-09-01 0:34 Ionen Wolkens
2022-08-02 15:37 Ionen Wolkens
2022-07-16 17:03 Ionen Wolkens
2022-07-13 14:44 Ionen Wolkens
2022-07-13 14:39 Ionen Wolkens
2022-06-28 7:46 Ionen Wolkens
2022-05-17 4:21 Ionen Wolkens
2022-05-14 2:23 Ionen Wolkens
2022-05-13 2:48 Ionen Wolkens
Reply instructions:
You may reply publicly to this message via plain-text email
using any one of the following methods:
* Save the following mbox file, import it into your mail client,
and reply-to-all from there: mbox
Avoid top-posting and favor interleaved quoting:
https://en.wikipedia.org/wiki/Posting_style#Interleaved_style
* Reply using the --to, --cc, and --in-reply-to
switches of git-send-email(1):
git send-email \
--in-reply-to=1744038319.51ab4b7dfc1851c865366457ad56c014fc0b867d.ionen@gentoo \
--to=ionen@gentoo.org \
--cc=gentoo-commits@lists.gentoo.org \
--cc=gentoo-dev@lists.gentoo.org \
/path/to/YOUR_REPLY
https://kernel.org/pub/software/scm/git/docs/git-send-email.html
* If your mail client supports setting the In-Reply-To header
via mailto: links, try the mailto: link
Be sure your reply has a Subject: header at the top and a blank line
before the message body.
This is a public inbox, see mirroring instructions
for how to clone and mirror all data and code used for this inbox